/* mc8prim.h - primitives for MC8-HSP/DSP-ISA cards */

#include <stdlib.h>
#include <stdio.h>
/* #include <conio.h>*/
#include "mc8prim.h"

/************************************************/
/* mc8Open                                      */
/*   - Allocate and initialze board data struct */
/*   - lAddr - port address for the board       */
/*   - wIrq - irq addr for the board            */
/*   - wForce - set to 1 to always open board,  */
/*              even if communication fails     */
/************************************************/
mc8_struct *mc8Open(long lAddr, int wIrq, int wForce)
{
}

/*************************************************************/
/* mc8ReadMem
/*   - read memory from MC8-DSP-ISA                          */
/*   - if addr >= 0x400000, reads external mem via a chunk   */
/*     of on-chip memory (2 DMA accesses)                    */
/*   - cWords is number of SHARC words (x2 or x3 for shorts) */
/*   - Instr vs Data (48/32 bits) done via flag in lAddr     */
/*************************************************************/
int mc8ReadMem(mc8_struct *pmc8Info, long lAddr, short *rgwData, 
			int cWords)
{
}

/*************************************************************/
/* mc8WriteMem                                               */
/*   - write memory to MC8-DSP-ISA                           */
/*   - if addr >= 0x400000, writes external mem via a chunk  */
/*     of on-chip memory (2 DMA accesses)                    */
/*   - cWords is number of SHARC words (x2 or x3 for shorts) */
/*   - Instr vs Data (48/32 bits) done via flag in lAddr     */
/*************************************************************/
int mc8WriteMem (mc8_struct *pmc8Info, long lAddr, short *rgwData, 
			int cWords)
{
}

/************************************************/
/* mc8Close                                     */
/*   - Free board data struct and its pointers  */
/************************************************/
int mc8Close(mc8_struct *pmc8Info)
{
}
