/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by Mike Parker.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#ifndef _CTREE_H_
#define _CTREE_H_

/* Definitions useful required for the Ctree matcher. 
  
   NOTE: this definition file assumes the user of 'key_buf' as the name
   for the buffer in which matches are returned.

*/

#include <stdio.h>
#include "../h/protoDef.h"
#include "../h/varargInc.h"

#ifdef __cplusplus
extern "C"
{
#endif

char *tree_match_parse VA_PROTO((char *,...));
char *tree_match_err_at PROTO(());
int *tree_match_flags PROTO(());

#define CTREE_F_DEBUG 0x00000001
#define CTREE_F_NOTTY 0x00000002

int tree_match_set_flags PROTO((int flags));
int tree_match_clear_flags PROTO((int flags));
void tree_match_sig_catch_on PROTO((int signum));
void tree_match_sig_catch_off PROTO((int signum));
void tree_match_set_get_routine PROTO((int (*getfxn)()));
void tree_match_set_put_routine PROTO((int (*putfxn)()));
void tree_match_set_flush_routine PROTO((int (*flushfxn)()));
void tree_match_set_input_stream PROTO((FILE*));
void tree_match_set_output_stream PROTO((FILE*));
FILE *tree_match_input_stream PROTO(());
FILE *tree_match_output_stream PROTO(());
void tree_match_setup PROTO(());
void tree_match_reset PROTO(());
void tree_match_debug_set PROTO((int on));
void tree_match PROTO((char *tree, char *prompt, char *buf));
int tree_match_nb PROTO((char *tree, char *prompt, char *buf, int *fdp));
int tree_match_flush_output PROTO(());

#define	COMMAND(s)	(strcmp (key_buf, s) == 0)
#define	COMMANDS(s)	(strncmp (key_buf, s, strlen(s)) == 0)

#ifdef __cplusplus
}
#endif

#endif
