/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#ifndef _SIMDRIVER_H_
#define _SIMDRIVER_H_

#include "../h/protoDef.h"
#include "../h/IOdevice.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define SIM_BUFSIZE	256	/* max. no. of bytes per xfer */

struct signalinfo {
	int pid;
	int signum;
};

struct simreg {
	int sd;
	int obd;
	unsigned short state;
#define SIM_NO_WAIT	0
#define SIM_READ_WAIT	1
#define SIM_WRITE_WAIT	2
#define SIM_SIGNAL_ACK	3
	struct signalinfo siginfo;
	int readCount;
	int writeCount;
};

extern simRead PROTO((IO_DEVICE *dev, void *buf, int size));
extern simTestRead PROTO((IO_DEVICE *dev));
extern simWrite PROTO((IO_DEVICE *dev, void *buf, int size));
extern simTestWrite PROTO((IO_DEVICE *dev));

extern simProbe PROTO((IO_DEVICE *dev));
extern simAttach PROTO((IO_DEVICE *dev));
extern simDetach PROTO((IO_DEVICE *dev));
extern simSignal PROTO((IO_DEVICE *dev, int num));

extern simIoctl PROTO((IO_DEVICE *dev, int com, void *data));

#ifdef __cplusplus
}
#endif

#endif
