#include "../h/rcclDefs.h"
#include "../h/robot_jls.h"
#include "../h/errorCodes.h"
#include "../h/errorStack.h"

#include "../rccl/rcclAutoAbort.h"
#include "../rccl/rcclErrorMsgs.h"

JNTS *initJntsByName (jr, name)
JNTS *jr;
const char *name;
{
	char *fxnName = "initJntsByName()";
	JLS *jls;
	
	if (!planningLevelCheck(fxnName))
	 { return (NULL);
	 }
	MASK_RCI_AUTO_ABORT();
	if ((jls = getJls(name)) == NULL)
	 { if (getErrorCode(0) != EMemory &&
	       getErrorCode(0) != ENotDefined)
	    { errorMsg (EInternal, rcclNullMsg, fxnName);
	    }
	   else
	    { errorMsg (getErrorCode(0), rcclNullMsg, fxnName);
	    }
	   RETURN_ERROR(NULL);
	 }
	else
	 { jr->num = jls->numJ;
	   strcpy (jr->type, jls->jtype);
	   RETURN_NORMAL(jr);
	 }
}


