/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
/*---------------------------------------------------------------------------
 *		
 * MODULE NAME:	rcclErrorMsgs
 *
 * DESCRIPTION:	Common error messages used by RCCL routines.
 *
 *		We make these global to save space.
 *
 * AUTHOR/DATE:	John Lloyd, Fall 1989
 *
 * MODIFICATION HISTORY:
 *
 *--------------------------------------------------------------------------*/

char *rcclNullMsg 	= "%s --\n";
char *rcclBadTrsfMsg    = "%s -- illegal transform pointer 0x%x\n";
char *rcclNullFxnMsg	= "%s -- null function specified\n";
char *rcclBadFxnMsg     = "%s -- function 0x%x not part of control code\n";
char *rcclBadFxnBindMsg	= "%s -- function binding 0x%x is bogus\n";
char *rcclTrsfCtrlMsg	= "%s -- error reported by transCtrl()\n";
char *rcclNoTasksMsg	= "%s -- RCCL control level not set up yet\n";
char *rcclCantGetSmemMsg = "%s -- can't get shared memory\n";
char *rcclCantGetGmemMsg = "%s -- can't get global memory\n";
char *rcclCantGetLmemMsg = "%s -- can't get local memory\n";
char *rcclCantGetTrsfMsg = "%s -- can't get TRSF 0x%x\n";
char *rcclCantGetPosMsg = "%s -- can't get POS 0x%x\n";
char *rcclVirtMnpMsg =    "%s -- not defined for virtual manipulators\n";
char *rcclNotVirtMnpMsg = "%s -- only defined for virtual manipulators\n";
char *rcclArgLeqMsg 	= "%s -- argument(s) <= %g\n";
char *rcclArgNegMsg 	= "%s -- negative argument(s)\n";
char *rcclPausedMsg	= "%s -- system is paused\n";
char *rcclBadSpecStrMsg = "%s -- bad specification string\n";
char *rcclArgNullMsg	= "%s -- NULL argument(s)\n";
char *rcclNoTrsfMsg	= "%s -- transform 0x%x not part of position\n";
char *rcclNotActiveMsg	= "%s -- RCCL control level not active\n";
char *rcclIsActiveMsg	= "%s -- RCCL control level is active\n";
char *rcclBadMflagMsg	= "%s -- bad motion flag number\n";
char *rcclArgRangeMsg	= "%s -- argument should be between %d and %d\n";
char *rcclTgenErrorMsg	= "trajectory generator -- internal error %s\n";
char *rcclBadSignumMsg	= "%s -- illegal signal number %d\n";
char *rcclNoVmJmodeMsg	= 
	"%s -- joint interpolation not defined for virtual manipulators\n";
char *rcclBadArgMsg	= "%s -- illegal argument value (%d)\n";
char *rcclCantInitMsg	= "%s -- can't do initializations\n";
char *rcclDuplicateMsg	= "%s -- '%s' already created\n";
char *rcclNoCpuMsg	= "%s -- can't provide a CPU\n";
char *rcclTaskSetupMsg	= "%s -- trouble setting up control task(s)\n";
char *rcclAllocMemMsg	= "%s -- can't allocate required memory or objects\n";
char *rcclNoParamSetMsg	= "%s -- external parameter set '%s' not found\n";
char *rcclBadParamMsg	= "%s -- external parameter '%s' badly defined\n";
char *rcclTooManyMsg	= "%s -- number of %s exceeds %d\n";
char *rcclMotionReqMsg	= "%s -- error queuing motion request\n";
char *rcclRangeLimMsg	= "%s -- value %g for joint %d is out of range\n";
char *rcclNoT6TransMsg	= "%s -- no T6 transform in position equation\n";
