/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd and Vincent Hayward.	    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

/*---------------------------------------------------------------------------
 *		
 * MODULE NAME:	copyTrsf
 *
 * DESCRIPTION:	Routines for copying all or part of a TRSF structure.
 *
 * AUTHOR/DATE:	Vincent Hayward, Purdue University, 1983.
 *		CVaRL installation by John Lloyd
 *
 * MODIFICATION HISTORY:
 *
 *--------------------------------------------------------------------------*/

#include "../h/robotTypes.h"

TRSF *copyTrsf(tr, t1) /*::*/
register TRSF *tr, *t1;
{
	/* Copy the whole thing ... a bit out of date */

	tr->n = t1->n;
	tr->o = t1->o;
	tr->a = t1->a;
	tr->p = t1->p;
	return(tr);
}

TRSF *copyTrsfXyz(tr, t1) /*::*/
register TRSF *tr, *t1;
{
	/* Copy only the translation part */

	tr->p = t1->p;
	return(tr);
}

TRSF *copyTrsfNoa(tr, t1) /*::*/
register TRSF *tr, *t1;
{
	/* Copy only the rotation part */

	tr->n = t1->n;
	tr->o = t1->o;
	tr->a = t1->a;
	return(tr);
}
