/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
#include "../h/cdefs.h"
#include "../h/robotClass.h"

#include "../h/puma_kynvar.h"
#include "../h/scara_kynvar.h"
#include "../h/stan_kynvar.h"
#include "../h/elbow_kynvar.h"
#include "../h/gantry_kynvar.h"
#include "../h/stage_kynvar.h"
#include "../h/linear_kynvar.h"

#include "robotData.h"

extern puma_jls();
extern puma_kyn();
extern puma_startup();
extern puma_input();
extern puma_output();
extern puma_release();

extern elbow_jls();
extern elbow_kyn();

extern stan_jls();
extern stan_kyn();

extern scara_jls();
extern scara_kyn();

extern gen_startup();
extern gen_input();
extern gen_output();
extern gen_release();

extern crs_startup();
extern crs_input();
extern crs_output();
extern crs_release();

extern gantry_jls();
extern gantry_kyn();
extern gantry_startup();
extern gantry_input();
extern gantry_output();
extern gantry_release();

extern stage_jls();
extern stage_kyn();
extern stage_startup();
extern stage_input();
extern stage_output();
extern stage_release();

extern linear_jls();
extern linear_kyn();
#if defined(X86sol_TARGET) || defined(X86Linux_TARGET)
extern pmc_startup();
extern pmc_input();
extern pmc_output();
extern pmc_release();
#endif

#ifdef Tsp_TARGET
#define puma_startup	NULLF
#define puma_input	NULLF
#define puma_output	NULLF
#define puma_release	NULLF
#endif

#if defined(X86sol_TARGET)
extern puma_ati_startup();
extern puma_ati_input();
extern puma_ati_output();
extern puma_ati_release();
#endif

ROBOT_DATA_ENTRY rciRobotDataTable[] =
{
	"puma260",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_1",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_2",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_3",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_4",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_5",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_6",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_7",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_8",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_9",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma560_10",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"puma760",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"goldenChild",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"blue",		PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"frank",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,

	"caesar",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			crs_startup, crs_input, 
			crs_output, crs_release,

#if defined(X86sol_TARGET)
	"thumper",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_ati_startup, puma_ati_input, 
			puma_ati_output, puma_ati_release,
	"thumpernf",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,
#else
	"thumper",	PUMA, puma_jls, puma_kyn,
			sizeof(PUMA_KYN), sizeof(PUMA_VAR),
			puma_startup, puma_input, 
			puma_output, puma_release,
#endif
#if defined(X86sol_TARGET)
	"gantry",	GANTRY, gantry_jls, gantry_kyn,
			sizeof(GANTRY_KYN), sizeof(GANTRY_VAR),
			gantry_startup, gantry_input, 
			gantry_output, gantry_release,
	"stage",	STAGE, stage_jls, stage_kyn,
			sizeof(STAGE_KYN), sizeof(STAGE_VAR),
			pmc_startup, pmc_input, 
			pmc_output, pmc_release,
	"linear",	LINEAR, linear_jls, linear_kyn,
			sizeof(LINEAR_KYN), sizeof(LINEAR_VAR),
			pmc_startup, pmc_input, 
			pmc_output, pmc_release,
#else
	"gantry",	GANTRY, gantry_jls, gantry_kyn,
			sizeof(GANTRY_KYN), sizeof(GANTRY_VAR),
			gen_startup, gen_input, 
			gen_output, gen_release,
	"stage",	STAGE, stage_jls, stage_kyn,
			sizeof(STAGE_KYN), sizeof(STAGE_VAR),
			gen_startup, gen_input, 
			gen_output, gen_release,
	"linear",	LINEAR, linear_jls, linear_kyn,
			sizeof(LINEAR_KYN), sizeof(LINEAR_VAR),
			gen_startup, gen_input, 
			gen_output, gen_release,
#endif
#ifndef Tsp_TARGET
	"elbow",	ELBOW, elbow_jls, elbow_kyn,
			sizeof(ELBOW_KYN), sizeof(ELBOW_VAR),
			gen_startup, gen_input, 
			gen_output, gen_release,

	"stan",		STAN,  stan_jls, stan_kyn,
			sizeof(STAN_KYN), sizeof(STAN_VAR),
			gen_startup, gen_input, 
			gen_output, gen_release,

	"scara",	SCARA, scara_jls, scara_kyn,
			sizeof(SCARA_KYN), sizeof(SCARA_VAR),
			NULLF, NULLF, NULLF, NULLF, 
#endif

	0,		0, NULLF, NULLF, /* zero denotes the end */
			0, 0, NULLF, NULLF, NULLF, NULLF, 
			
};

#if 0
typedef struct {
	char *name;
	int value;
} NAME_VALUE_DESC;

static NAME_VALUE_DESC classNameList[] = {
	"PUMA", PUMA,
	"XRAY", XRAY,
};

static NAME_VALUE_DESC typeNameList[] = {
	"Puma_260", Puma_260,
	"Puma_560", Puma_560,
	"Puma_760", Puma_760,
};

int rbtGetClassByName(name)
char *name;
{
	register int i;

	for (i=0; i<ARRAY_SIZE(classNameList); i++)
	 { if (strcmp(classNameList[i].name,name)==0)
	    { return(classNameList[i].value);
	    }
	 }
	return(UNDEF);
}

int rbtGetTypeByName(name)
char *name;
{
	register int i;

	for (i=0; i<ARRAY_SIZE(typeNameList); i++)
	 { if (strcmp(typeNameList[i].name,name)==0)
	    { return(typeNameList[i].value);
	    }
	 }
	return(UNDEF);
}

char *rbtGetNameOfClass(value)
int value;
{
	register int i;

	for (i=0; i<ARRAY_SIZE(classNameList); i++)
	 { if (classNameList[i].value == value)
	    { return(classNameList[i].name);
	    }
	 }
	return(NULL);
}

char *rbtGetNameOfType(value)
int value;
{
	register int i;

	for (i=0; i<ARRAY_SIZE(typeNameList); i++)
	 { if (typeNameList[i].value == value)
	    { return(typeNameList[i].name);
	    }
	 }
	return(NULL);
}
#endif



       
	
