/*
	C library - ascii to floating
*/

#include <math.h>
#include <ctype.h>

#define LOGHUGE	307

double
strtod(p, ptr)
register char *p;
char **ptr;
{
	register int c;
	double fl, flexp, exp5;
#if 0
	double big = 72057594037927936.;  /*2^56*/
#endif
	double big = 4503599627370496.;   /*2^52*/
	double ldexp();
	int nsigd, nd;
	register int eexp, exp, neg, negexp, bexp;
	char *psave;

	if (ptr) 
		*ptr = p;

	neg = 1;
	while((c = *p++) == ' ')
		;
	if (c == '-')
		neg = -1;
	else if (c=='+')
		;
	else
		--p;

	exp = 0;
	fl = 0;
	nsigd = 0;
	nd = 0;
	while ((c = *p++), isdigit(c)) {
		if (fl<big) {
			fl = 10*fl + (c-'0');
			if (fl) nsigd++;
		}
		else
			exp++;
		nd++;
	}

	if (c == '.') {
		while ((c = *p++), isdigit(c)) {
			if (fl<big) {
				fl = 10*fl + (c-'0');
				if (fl) nsigd++;
				exp--;
			}
			nd++;
		}
	}
	if (nd == 0)
		return (0.0);
	
	negexp = 1;
	eexp = 0;
	if ((c == 'E') || (c == 'e')) {
		psave = p;
		nd = 0;
		if ((c= *p++) == '+')
			;
		else if (c=='-')
			negexp = -1;
		else
			--p;

		while ((c = *p++), isdigit(c)) {
			eexp = 10*eexp+(c-'0');
			nd++;
		}
		if (nd == 0) {
			p = psave;
			negexp = 1;
			eexp = 0;
		}
		else {
			if (negexp<0)
				eexp = -eexp;
		}
		exp = exp + eexp;
	}

	negexp = 1;
	if (exp<0) {
		negexp = -1;
		exp = -exp;
	}

	/* Check for underflow */
	if((nsigd+exp*negexp) < -LOGHUGE){
		fl = 0;
		exp = 0;
	}
	flexp = 1;
	exp5 = 5;
	bexp = exp;
	/* compute flexp = 5^exp ( so that 10^exp = flexp 2^exp ) */
	for (;;) {
		if (exp&01)
			flexp *= exp5;
		exp >>= 1;
		if (exp==0)
			break;
		exp5 *= exp5;
	}
	if (negexp<0)
		fl /= flexp;
	else
		fl *= flexp;
	fl = ldexp(fl, negexp*bexp);
	if (neg<0)
		fl = -fl;
	if (ptr) 
		*ptr = p-1;
	return(fl);
}

double atof(s)
char *s;
{
	return (strtod (s, (char**)0));
}

#if 0
main()
{
	char buf[80];
	char *check;
	double l;

	while (1)
	 { gets(buf);
	   l = mystrtod(buf,&check);
	   printf ("%g %d\n", l, check-buf);
	 }
}
#endif
