/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include "../h/cdefs.h"

#ifdef VXW_TARGET

#include "../h/stringDefs.h"
#include "../h/utilFxns.h"

static char *RCCLenv = NULL;
static char *HOMEenv = NULL;

rciSetenvRCCL(name)
char *name;
{
	if (RCCLenv)
	 { free (RCCLenv);
	 }
	RCCLenv = strcpy((char*)malloc(strlen(name)+1),name);
}

rciSetenvHOME(name)
char *name;
{
	if (HOMEenv)
	 { free (HOMEenv);
	 }
	HOMEenv = strcpy((char*)malloc(strlen(name)+1),name);
}

typedef struct envNode {
	struct *envNode next;
	  char *name;
	  char *str;
} EnvNode;

static EnvNode *env;

void vxwSetenv(name, str)
char *name;
char *str;
{
	EnvNode *node;

	for (node=env; node!=NULL; node=node->next)
	 { if (strcmp(name,node->name) == 0)
	    { break;
	    }
	 }
	if (node==NULL)
	 { node = malloc(sizeof(EnvNode));
	   node->name = strcpy((char*)malloc(strlen(name)+1),name);
	   node->next = env;
	   env = node;
	 }
	else
	 { free (node->str);
	 }
	node->str = strcpy((char*)malloc(strlen(str)+1),str);
}

char *vxwGetenv(name)
char *name;
{
	EnvNode *node;

	for (node=env; node!=NULL; node=node->next)
	 { if (strcmp(name,node->name) == 0)
	    { break;
	    }
	 }
	return (node==NULL ? NULL : node->str);
}

#else
extern char* getenv();
#endif

char *getenvRCCL()
{
#ifdef VXW_TARGET
	return (RCCLenv);
#else
	return (getenv("RCCL"));
#endif
}

char *getenvHOME()
{
#ifdef VXW_TARGET
	return (HOMEenv);
#else
	return (getenv("HOME"));
#endif
}

char *rciGetenv(name)
char *name;
{
#ifdef VXW_TARGET
	return (vxwGetenv(name));
#else
	return (getenv(name));
#endif
}

char *getPathTargetName ()
{
	/* return the string "RCCL_PATH_<TARGET>" */

	static char *str = NULL;

	if (str == NULL)
	 { str = (char*)malloc(strlen("RCCL_PATH_")+strlen(TARGET_SYSTEM)+1);
	   strcpy (str, "RCCL_PATH_");
	   strcat (str, TARGET_SYSTEM);
	 }
	return (str);
}

char *getenvPathTarget ()
{
	/* return the contents of the environment variable
	   RCCL_PATH_<TARGET>, if it exists, or NULL
	   otherwise. */

#ifdef VXW_TARGET
	return (vxwGetenv(getPathTargetName()));
#else
	return (getenv(getPathTargetName()));
#endif
}


