#ifndef _ATIIOCTL_H_WRAP_
#define _ATIIOCTL_H_WRAP_

#include <sys/ioccom.h>

#ifdef _SYS_IOCCOM_H
#   define ATI_IOCTL_CODE       'A'
#else
#   ifdef __STDC__
#      define ATI_IOCTL_CODE       'A'
#   else
#      define ATI_IOCTL_CODE        A
#   endif
#endif

#define ATI_GAGE_SATURATION	0x8000
#define ATI_GAGE_MASK		0x00ff
#define ATI_COND_TYPE_MASK	0x0003
#define ATI_COND_NUM_MASK	0xef00

#define ATI_OVERFLOW		0xffff

typedef struct {
	unsigned short dword;
	short fdata[6];
} AtiForceRec;

typedef struct {
	short max[6];
	short min[6];
} AtiPeakValueRec;

typedef struct {
#define ATI_SENSOR_ERROR	0x01
#define ATI_RAM_ERROR		0x02
#define ATI_BIAS_ERROR		0x04
#define ATI_DSP_ERROR		0x08
#define ATI_OTHER_ERROR		0x10
	unsigned short ecode;
	unsigned short ramCheck;
	unsigned short gageCheck;
} AtiTestRec;

typedef struct {
	long calmat[48];
} AtiCalMatrixRec;

typedef struct {
	short bias[8];
} AtiBiasRec;

typedef struct {
	long calmat[48];
	short bias[8];
	short mm[8];
	short bm[8];
	short mb[8];
	short bb[8];
	short numGages;
	short cntsPerForce;
	short cntsPerTorque;
	short maxForce;
	short maxTorque;
	short maxTemperature;
	short minTemperature;
	short units;
	short serialNum;
} AtiSensorRec;	

typedef struct {
	unsigned short oflags;
	unsigned short dmask;
	unsigned short intrEnable;
	unsigned short sampleRate;
} AtiCardDataRec;
	
#define ATIIOC_GET_SENSOR_INFO	_IOR(ATI_IOCTL_CODE,1,AtiSensorRec*)
#define ATIIOC_GET_BIAS		_IOR(ATI_IOCTL_CODE,2,AtiBiasRec*)
#define ATIIOC_SET_BIAS		_IOW(ATI_IOCTL_CODE,3,AtiBiasRec*)
#define ATIIOC_TEST_RESET	_IOR(ATI_IOCTL_CODE,4,AtiTestRec*)
#define ATIIOC_SET_CAPBUF_SIZE	_IOW(ATI_IOCTL_CODE,5,int)
#define ATIIOC_GET_CAPBUF_SIZE	_IOR(ATI_IOCTL_CODE,6,int*)
#define ATIIOC_GET_FORCE_DATA	_IOR(ATI_IOCTL_CODE,7,AtiForceRec*)
#define ATIIOC_SET_CALMATRIX	_IOW(ATI_IOCTL_CODE,8,AtiCalMatrixRec*)
#define ATIIOC_GET_CALMATRIX	_IOR(ATI_IOCTL_CODE,9,AtiCalMatrixRec*)
#define ATIIOC_GET_PEAK_DATA	_IOR(ATI_IOCTL_CODE,10,AtiPeakValueRec*)
#define ATIIOC_GET_PEAK_RESET	_IOR(ATI_IOCTL_CODE,11,AtiPeakValueRec*)

#define ATI_FILTER_MASK		0x0003
#define ATI_FILTER_2SAMP	0x0001
#define ATI_FILTER_4SAMP	0x0002
#define ATI_FILTER_8SAMP	0x0004
#define ATI_SOFTBIAS_ENABLE	0x0008
#define ATI_TEMPCOMP_ENABLE	0x0010
#define ATI_CALIB_ENABLE	0x0020
#define ATI_PEAK_HOLD_ENABLE	0x0040
#define ATI_MONITOR_ENABLE	0x0080
#define ATI_SATCHECK_ENABLE	0x0100

#define ATIIOC_SET_OPFLAGS	_IOW(ATI_IOCTL_CODE,12,unsigned int)
#define ATIIOC_GET_OPFLAGS	_IOR(ATI_IOCTL_CODE,13,unsigned int*)
#define ATIIOC_SET_CAPTURE	_IOW(ATI_IOCTL_CODE,14,int)
#define ATIIOC_GET_CAPTURE_RATE	_IOR(ATI_IOCTL_CODE,15,int*)
#define ATIIOC_RESET_BIAS	_IO(ATI_IOCTL_CODE,16)

#define ATIIOC_ENABLE_IOPORTS   _IOW(ATI_IOCTL_CODE,30,int)

#endif
